<template lang="pug">
div
  h1 Painters

  table

    tr
      td Painter 
      td
        select(v-model="painterName")
          option(value="basic") Basic

    tr
      td Latest event 
      td {{ device.latestEvent }}


  div(:class="$css.keyImages")
    template(v-for="i of 32")
      div
        template(v-if="key = device.layout.keys[i-1]")
          key-canvas(:painter="painterName", :config="key.views.default", v-if="!device.keyStates?.[i-1] || device.keyStates[i-1] === 'default'")
          key-canvas(:painter="painterName", :config="Object.assign({}, key.views.default, key.views[device.keyStates[i-1]])", v-else)

  </template>
  
  
<style lang="scss" module="$css">
  .keyImages {
    display: grid;
    gap: 5px;
    grid-template-columns: repeat(8, 120px);
    grid-auto-rows: 120px;
    margin-top: 2em;
    background: #111;
    padding: 5px;
    
    >div {
      
      >img {
        width: 100%;
        min-width: 100%;
      }

    }
  }
</style>

  
  <script lang="js">
  
  import { useDevice, useMapper, useGlobalSettings } from '@bitaffair/vue-streamdeck';

  
  import { ref, defineComponent, computed, unref, watchEffect } from 'vue';
  
  
  import KeyCanvas from '../components/keycanvas.vue';


  const STREAMDECK_DEVICE_SERIAL_A = 'AL49I2C06510';
  const STREAMDECK_DEVICE_SERIAL_B = 'CL21L2A04476';
  
  const makeToggleEvents = () => {
    return {
      down({ key, state }) {
        this.setKeyState(key, state === 'active' ? 'default' : 'active');
      }
    }
  };
  
  export default {
    components: {
      KeyCanvas
    },

    setup() {
  
      const painterName = ref('basic');
  
      const streamDeckSettings = useGlobalSettings();
  
    
  
      const appMapper = useMapper('app-1', {
        defaultMapping: {
          'A': 0,
          'B': 1
        }
      });
  
      const devicePointerA = appMapper.serial('A')

  
      const arr = new Array(32).fill(0);
  
    
      const device = useDevice(devicePointerA,{ exclusive:true });
       
  
      watchEffect(() => {

        device.layout.keys = {

          0: {
            events: makeToggleEvents(),
            painter: unref(painterName),
            views: {
              default: {
                index: 'A' + String(1).padStart(3, '0') + ' Hans Peter Wurst',
                label:  'Hans Peter Wurst',
              },
              active: {
                backgroundColor: '#033E3E',
                color: '#FFFDD0'
              }
            }
          },

          1: {
            events: makeToggleEvents(),
            painter: unref(painterName),
            views: {
              default: {
                label:  'Dieter',
              },
              active: {
                color: 'red'
              }
            }
          },

          2: {
            events: makeToggleEvents(),
            painter: unref(painterName),
            views: {
              default: {
                label:  'Prof. Dr. Jochen Peter Metternich',
              },
              active: {
                backgroundColor: 'teal'
              }
            }
          },

          4: {
            events: makeToggleEvents(),
            painter: unref(painterName),
            views: {
              default: {
                label:  'Prof. Dr. Jochen Peter Metternich',
              },
              active: {
                backgroundColor: '#660066',
                color:'yellow'
              }
            }
          }



        }
      })


  
      return {
        device,
        
        painterName,
        streamDeckSettings
      }
    }
  }
  
  </script>